;  TouchOSC layout slider/rotary knob/ X/Y controller and button/pad test

;  Sliders/rotary knobs = Continuous Controllers (CCs)
;  Buttons = MIDI notes (fixed velocity); Pads include velocity control
;  Before running, check MIDI device # (-Mx in <CsOptions>) and values
;    for CHANnel, initial CTRL (Controller) and MIDI NOTE #'s
;  Note the special CTRL flag for multichannel slider GUIs
:  All included TouchOSC layouts use the default values below

<CsoundSynthesizer>
<CsOptions>

-odac -M0 -m0d -b128 -B2048 -+raw_controller_mode=1

</CsOptions>
<CsInstruments>

sr	  =	44100
ksmps	  =	100
nchnls    =     2

#define CHAN    #1# ; valid = 1 to 16
#define CTRL    #20# ; 1st # of up to 16 consecutive; valid = -1 to 112+ ;
;                     -1 = CC7, channel 1 up to 16 (notes are on single channel)
#define NOTE    #60# ; 1st MIDI note # of up to 16 consecutive; valid = 0 to 112+

        instr 1
   
kndx    =        0
kncr    =        1
kmax    =        16

kstat,kchan,k1,k2 midiin
        if kstat == 0 goto end
        if ((kstat == 144) || (kstat == 128)) && (kchan == $CHAN) then          

start_loop:
        if k1 == $NOTE + kndx then
        if kstat == 144 then
        tabw     k2 * 16, kndx, 2
        else
        tabw     k2 * 0, kndx, 2
        endif
        endif
        loop_lt  kndx, kncr, kmax, start_loop
                        
        elseif kstat == 176 then
        
start_loop2:
        if ($CTRL > -1) && (kchan == $CHAN) then
        if k1 == ($CTRL + kndx) then
        tabw     k2 * 16, kndx, 1
        endif
        elseif (k1 == 7) && (kchan == kndx + 1) then
        tabw     k2 * 16, kndx, 1
        endif
        loop_lt  kndx, kncr, kmax, start_loop2

        endif
                
end:    endin
        
        instr 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17; controllers
        
ipch    =        8 + ((p1 - 2) * .01)
icps    =        cpspch(ipch)
kamp    tab      p1 - 2, 1
kamp2   port     kamp, .02
a1      lfo      kamp2, icps
        
        outs     a1, a1        

        endin
                
        instr 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37; notes
        
ipch    =        8 + ((p1 - 22) * .01)
icps    =        cpspch(ipch)
kamp    tab      p1 - 22, 2
kamp2   port     kamp, .01
a1      lfo      kamp2, icps, 1
        
        outs     a1, a1        

        endin

</CsInstruments>
<CsScore>

f1 0 16 -2 0
f2 0 16 -2 0
i1 0 3600
i2 0 3600
i3 0 3600
i4 0 3600
i5 0 3600
i6 0 3600
i7 0 3600
i8 0 3600
i9 0 3600
i10 0 3600
i11 0 3600
i12 0 3600
i13 0 3600
i14 0 3600
i15 0 3600
i16 0 3600
i17 0 3600
i22 0 3600
i23 0 3600
i24 0 3600
i25 0 3600
i26 0 3600
i27 0 3600
i28 0 3600
i29 0 3600
i30 0 3600
i31 0 3600
i32 0 3600
i33 0 3600
i34 0 3600
i35 0 3600
i36 0 3600
i37 0 3600

</CsScore>
</CsoundSynthesizer> 