<CsoundSynthesizer>
<CsOptions>
; Select audio/midi flags here according to platform
; Audio out   Audio in    No messages
;-odac           -iadc     -d     ;;;RT audio I/O

csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384  
</CsOptions>
<CsInstruments>

;Here is an instrument which can find out whether it is tied to a previous note (tival returns 1), and whether it is held (negative p3). Attack and release are handled accordingly: 


sr = 44100
ksmps = 32
nchnls = 1

instr 10
        
  ifunc=p6					 ;select basic waveform

  icps     init      cpspch(p5)                  ;Get target pitch from score event
  iportime init      abs(p3)/3                   ; Portamento time dep on note length
  iamp0    init      ampdb(p4)                   ; Set default amps
  iamp1    init      ampdb(p4)
  iamp2    init      ampdb(p4)
      			 				 		 		
  itie     tival                                 ; Check if this note is tied,
  if itie  ==  1     igoto nofadein              ; if not fade in
  iamp0    init      0

 nofadein:
  if p3    < 0       igoto nofadeout             ; Check if this note is held, if not fade out
  iamp2    init      0    

 nofadeout:
  ; Now do amp from the set values:
  kamp     linseg    iamp0, .03, iamp1, abs(p3)-.03, iamp2
        
  ; Skip rest of initialization on tied note:
           tigoto    tieskip

  kcps     init      icps                        ; Init pitch for untied note
  kcps     port      icps, iportime, icps        ; Drift towards target pitch
  

  kpw      oscil     .4, rnd(1), 1, rnd(.7)      ; A simple triangle-saw oscil

  ;ar       vco       kamp, kcps, 3, kpw+.5, 1, 1/icps  ;as in original code, but clicking
  ar       vco       kamp, kcps, 3, 0.5, 1
     
  ; (Used in testing - one may set ipch to cpspch(p4+2)
  ;       and view output spectrum)
  ;       ar oscil kamp, kcps, 1

                          
	out ar
 tieskip:                                       ; Skip some initialization on tied note

endin


</CsInstruments>
<CsScore>

t 0 60
; Simple Sine Function
f1   0 8192 10 1 ; Sine

; inst.	start	dur   amp       freq    wv       
i10	1   	 2	65	9.05	1
i10	3   	 2	75	6.05	1 
i10	5   	 2	65	11.09	1

i10	7   	 -2	65	9.05	1
i10	9   	 -2	65	6.05	1 
i10	11   	 2	65	11.09	1
e

</CsScore>
</CsoundSynthesizer>

